﻿import numpy as np
import matplotlib.pyplot as plt
import os
from tkinter import *
from tkinter.filedialog import *
import csv
import statistics
from statistics import mean

# Initialisation des listes contenant les coordonnées de position, vitesse et accélération
x=[]
y=[]
vx=[]
vy=[]
ax=[]
ay=[]
t=[]


# Cette partie du code lit le tableau de valeurs présent dans "" et extrait les valeurs de t, x et y
Fenetre = Tk()
Nom_fichier=askopenfilename(title="Ouvrir le fichier contenant les valeurs de t, x et y", initialdir=os.getcwd(), initialfile="*.csv;*.txt", filetypes = [("Fichiers Textes tabulés CSV","*.txt;*.csv"),("All", "*.csv;*.txt")])
Fichier_Csv = open(Nom_fichier, 'r')
for ligne in Fichier_Csv:
    if not '(' in ligne :
        t.append(float(ligne.split()[0].replace(',','.')))
        x.append(float(ligne.split()[1].replace(',','.')))
        y.append(float(ligne.split()[2].replace(',','.')))
        #print 't='+ligne.split()[0].replace(',','.') + ' - x='+ligne.split()[1].replace(',','.')+ ' - y='+ligne.split()[2].replace(',','.')

Fichier_Csv.close()
Fenetre.destroy()


Nbre_Mesures=len(t) # nombre de positions enregistrées

# Préparation des fenêtres graphiques
fig=plt.figure(figsize=(16,9))
fig.patch.set_facecolor('#E0E0E0')
fig.patch.set_alpha(0.7)


""" =================== 
    Tracé des positions  
    =================== """


graphe = fig.add_subplot(211)                               # On travaille dans la zone graphique du haut
graphe.patch.set_facecolor('#525354')                       # Couleur du fond

plt.plot(x,y,'.',color='orchid',label='y(x)')               # Trace y en fonction de x 
plt.title("Positions de la boule de pétanque")              # Le titre du graphique
plt.xlabel("x (m)")                                         # La légende de l'axe des abscisses
plt.ylabel("y (m)")                                         # La légende de l'axe des ordonnées
plt.axis('equal')                                           # Pour que le repère soit orthonormé
plt.legend()                                                # Ajoute la légende
plt.grid()                                                  # Ajoute un quadrillage

""" ======================================== 
    Tracé des coordonnées du vecteur-vitesse  
    ======================================== """

graphe = fig.add_subplot(223)                               # On travaille dans la zone graphique en bas à gauche
graphe.patch.set_facecolor('#525354')                       # Couleur du fond

n = 0                       
while n < Nbre_Mesures-1 :
    vx.append ((x[n+1]-x[n])/(t[n+1]-t[n]))
    #    ETAPE ELEVE N°1 : saisir ici le code permettant le calcul des valeurs de vy
    n = n + 1
t.pop()                                                     # on efface la dernière valeur de la liste t


plt.plot(t,vx,'-',color='gold',label='vx(t)')               # Trace vx en fonction de t 
#   ETAPE ELEVE N°2 : saisir ici le code permettant le tracé de vy en fonction du temps"
plt.title("Coordonnées du vecteur-vitesse")                 # Le titre du graphique
plt.xlabel("t (s)")                                         # La légende de l'axe des abscisses
plt.ylabel(["vitesses en m/s"])                             # La légende de l'axe des ordonnées
plt.legend()                                                # Ajoute la légende
plt.grid()                                                  # Ajoute un quadrillage


""" ============================================= 
    Tracé des coordonnées du vecteur-accélération  
    ============================================= """

graphe = fig.add_subplot(224)                               # On travaille dans la zone graphique en haut à gauche
graphe.patch.set_facecolor('#525354')                       # Couleur du fond

# ETAPE ELEVE N°3 : saisir ici le code permettant le calcul des valeurs de ax, ay et leur représentation graphique en fonction du temps"


plt.show()      # Affiche l'ensemble des graphiques






